<template>
  <div v-if="chapter == item.numChapter">
    <el-row style="margin:0px 0 2rem 0;">
      <el-col
        :span="10"
        :class="[showEditAmortization == true || item.passesMade.length == item.numPasses ? 'border__orange' : '']"
      >
        <div style="margin: 20px 0 0 2.5rem">
          <div style="margin:30px 0">
            <div
              class="subtitle-styles flex"
              style="justify-content: space-between; align-items:center"
            >
              <div style="display: flex; flex-direction: row;align-items:center">
                <p>N° de pasadas:</p>
                <el-input
                  style="max-width: 50px;margin-left:10px;"
                  v-model="quantPass"
                  @change="validPass"
                  @keypress.native="isNumber()"
                ></el-input>
              </div>
              <el-button
                @click="changePasses"
                class="el-button--orange"
                size="small"
                type="primary"
                :disabled="isDisableBtnSavePasses"
              >Guardar</el-button>
            </div>
            <p v-if="showMessage.status" class="font-i-12 text-red mb-0 mt-5">*{{showMessage.text}}</p>
          </div>

          <div
            class="bg-orange subtitle-styles text-white flex justify-between p-10"
            style="margin-bottom:2rem"
          >
            <p>Precio Unitario:</p>
            <p>{{ item.unitPrice}}</p>
          </div>
          <!-- amortizaciones -->
          <div class="subtitle-styles">
            <span>
              Amortizaciones Realizadas
              <br />
            </span>
            <!-- <p
              class="font-i-12 text-red mb-0 mt-15"
            >* Las amortizaciones realizadas solo se mostrarán de las parrillas certificadas.</p>-->
            <div style="padding: 10px 0">
              <div v-if="item.passesMade.length > 0">
                <p
                  style="margin: 10px 0; font-weight: 400;"
                  v-for="(passe, index) in item.passesMade"
                  :key="index"
                >{{passe}}</p>
              </div>
              <p style="margin: 10px 0; font-weight: 400;" v-else>No hay pasadas realizadas</p>
            </div>
          </div>
          <hr class="line-card" />
          <div class="subtitle-styles">
            <span>
              Amortizaciones Por Realizar
              <br />
            </span>
            <div style="padding: 20px 0; margin-top: 15px">
              <div v-if="item.missingPasses.length > 0">
                <p
                  style="margin: 10px 0; font-weight: 400; "
                  v-for="(passe, index) in item.missingPasses"
                  :key="index"
                >{{passe}}</p>
              </div>

              <p v-else style="margin: 10px 0; font-weight: 400;">No hay pasadas por realizar</p>
            </div>
          </div>
          <hr class="line-card" />
          <div class="subtitle-styles">
            <span>
              Saldo Restante:
              <br />
            </span>
            <div class="flex justify-between text-orange" style="padding: 20px 0 40px 0">
              <span class="font-general text-orange">{{item.missingMount}}</span>
              <el-button
                v-if="isNotShowBtn"
                class="el-button--gray"
                @click="renderizTemplate()"
                size="small"
                type="primary"
              >AMORTIZAR</el-button>
            </div>
          </div>
        </div>
      </el-col>
      <el-col
        v-if="!isNotShowBtn"
        :span="14"
        class="subtitle-styles flex"
        style="justify-content: center; align-items: center; height: 100vh; line-heigth:1.6"
      >
        <div
          class="text-center font-size-20 p-20 px-150"
        >El material se amortizó en su totalidad y todas sus pasadas ya fueron consumidas.</div>
      </el-col>
      <!-- cards derecha  -->
      <el-col v-if="showEditAmortization" :span="14">
        <div style="padding:4rem 0 3rem 4rem">
          <div class="line-heigth">
            <el-row :gutter="15" style="padding:1rem 0rem 1rem">
              <el-col :span="11">
                <div class="subtitle-styles">
                  <span>
                    Numero de Amortizaciones:
                    <br />
                  </span>
                </div>
              </el-col>
              <p
                style="color:red; font-size: 12px;"
                v-if="alertMessage.show"
              >{{alertMessage.message}}</p>
              <el-col :span="3">
                <el-input
                  @change="showArray"
                  maxlength="2"
                  size="small"
                  v-model="numberAmort"
                  @keypress.native="isNumber()"
                ></el-input>
              </el-col>
            </el-row>
            <el-row style="padding: 0.5rem 0 0.5rem">
              <el-col :span="10">
                <div class="subtitle-styles">
                  <span>
                    Porcentaje de Amortizacion:
                    <br />
                  </span>
                </div>
              </el-col>
            </el-row>
            <!-- duplicado  -->
            <el-row style="padding: 0.5rem 0 0.5rem" v-for="(sem, i) in arrayAmort" :key="i">
              <el-col :span="2" :offset="12">
                <div>{{ i + 1 }}</div>
              </el-col>
              <el-col :span="3">
                <el-input
                  v-model="sem.percent"
                  @input="calculatePercent(arrayAmort)"
                  maxlength="10"
                  size="medium"
                  @keypress.native="isNumber()"
                ></el-input>
              </el-col>
              <el-col :span="1">
                <span>%</span>
              </el-col>
              <el-col :span="2" class="text-end" :offset="1">
                <i
                  @click="addElement(arrayAmort, i)"
                  class="el-icon-circle-plus text-orange"
                  style="font-size:25px"
                ></i>
              </el-col>
              <el-col :span="1" class="text-end">
                <i
                  @click="removeElement(arrayAmort, i)"
                  class="el-icon-remove text-gray"
                  style="font-size:25px"
                ></i>
              </el-col>
            </el-row>
            <el-row :gutter="15">
              <el-col :span="3" :offset="11">
                <span class="text-orange">
                  <strong>Total</strong>
                </span>
              </el-col>
              <el-col :span="4" class="text-center">
                <hr v-if="true" class="line-card" />
                <!-- <div v-if="totalAmortPercent > 1">{{ totalAmortPercent }} %</div> -->
                <div v-if="totalAmortPercent > 1">{{ totalAmortPercent }} %</div>
              </el-col>
            </el-row>
            <el-row :gutter="15" style="padding-top:4rem">
              <el-col :span="3" :offset="11">
                <el-button @click="cancelarAmortizacion" type="primary" plain size="small">CANCELAR</el-button>
              </el-col>
              <el-col :span="3" :offset="3">
                <el-button
                  :disabled="totalAmortPercent !== 100"
                  @click="realizarAmortizacion(arrayAmort, item)"
                  type="primary"
                  size="small"
                >REALIZAR</el-button>
              </el-col>
            </el-row>
          </div>
        </div>
      </el-col>
    </el-row>
  </div>
</template>

<script>
import ReturnButton from '@/components/ReturnButton.vue'
import AppModal from '@/components/AppModal.vue'
import { HTTP } from '@/main.js'
import isNumber from '@/mixins/isNumber.js'
import moment from 'moment'
moment.locale('es')

export default {
  name: 'MaterialAmortization',
  components: { ReturnButton, AppModal },
  props: {
    item: { type: Object, required: false },
    chapters: { type: Array, required: false },
    exedPercent: { type: Boolean, required: false },
    chapter: { type: [Number, String], required: false },
    listChapters: { type: Array, required: false },
    originalMaterial: { type: Object, required: false },
  },
  mixins: [isNumber],
  data() {
    return {
      showEditAmortization: false,
      quantPass: 0,
      numberAmort: '',
      arrayAmort: [],
      arrayCantidad: [],
      totalAmortPercent: '',
      alertMessage: {
        show: false,
        message: '',
      },
      chapterSelect: this.listChapters[0],
      listMissingAmorts: [],
      arraySend: [],
      userName: null,
    }
  },
  created() {
    this.quantPass = this.item.numPasses
  },
  computed: {
    isNotShowBtn() {
      let firsConditional = this.item.passesMade.length !== this.item.numPasses
      let secondConditional =
        this.item.numOcurrencia > this.item.passesMade.length
      return firsConditional && secondConditional
    },
    showMessage() {
      if (this.quantPass == '') {
        return { text: '', status: false }
      } else {
        let text = Number(this.quantPass)
          ? 'Debe cambiar el esquema de amortización'
          : 'Sólo números.'
        let status = this.item.numOcurrencia <= this.quantPass ? false : true
        let conditionalStatus = text == 'Sólo números.' ? true : status
        return { text, status: conditionalStatus }
      }
    },
    isDisableBtnSavePasses() {
      if (this.quantPass == '') {
        return true
      } else {
        return Number(this.quantPass) !==
          Number(this.originalMaterial.numPasses)
          ? false
          : true
      }
    },
  },
  methods: {
    validPass() {
      // if (this.quantPass < 0) {
      //   this.quantPass = 0
      // } else 
      if (this.quantPass < this.item.passesMade.length) {
        this.quantPass = this.item.passesMade.length
      }
    },
    decimal(number) {
      if (Number(number)) {
        return 'NaN'
      }
      var numberFloat = number.toFixed(3)
      var splitNumber = numberFloat.split('.')
      var cNumberFloat = number.toFixed(2)
      var cNsplitNumber = cNumberFloat.split('.')
      var lastChar = splitNumber[1].substr(splitNumber[1].length - 1)
      if (lastChar > 0 && lastChar < 5) {
        cNsplitNumber[1]--
      }
      return Number(splitNumber[0])
        .toLocaleString('en')
        .concat('.')
        .concat(cNsplitNumber[1])
    },
    showArray(val) {
      if (this.numberAmort < 0) {
        this.numberAmort = 0
      }
      let data = []
      let mount = this.numberAmort
      let result = mount > 0 ? Number((100 / val).toFixed(3)) : 0
      for (let i = 0; i < val; i++) {
        data.push({
          percent: result,
        })
      }
      this.arrayAmort = data

      if (this.arrayAmort.length > this.item.numPasses) {
        this.alertMessage.show = true
        this.alertMessage.message = `No puede ser mayor que ${this.item.numPasses}`
        setTimeout(() => {
          this.arrayAmort.length = this.item.numPasses
          this.numberAmort = this.item.numPasses
          this.alertMessage.show = false
          this.alertMessage.message = ''
          this.showArray(this.numberAmort)
        }, 1000)
      }

      let coso = this.arrayAmort.map((el) => {
        return Number(el.percent)
      })

      let total = 0

      this.arrayAmort.forEach((el, i, arr) => {
       
        if (i == arr.length - 1) {
          
          el.percent = 100 - total
          el.percent = Number((el.percent).toFixed(3))
          console.log(Number((el.percent).toFixed(3)))
          // el.percent = el.percent.toFixed(3)
        }
        total = total + el.percent
      })

      this.totalAmortPercent = total
      // this.totalAmortPercent =
      //   coso.length > 0 ? coso.reduce((a, b) => Number(a) + Number(b)) : 0
    },
    async changePasses() {
      let today = moment(moment().toDate()).format('DD/MM/YYYY')
      let objectSend = {
        conCode: this.item.geminisCodCont,
        matCode: this.item.geminisCodMat,
        capCode: this.item.numChapter,
        numberPasses: this.quantPass,
        fechaAdenda: today,
        userName: this.userName,
      }
      await HTTP.patch(
        'orclcontracts/Passes/UpdateNumberPasse',
        objectSend
      ).then((res) => {
        console.log(res)
        this.$emit('saveChangePasse')
        this.$emit('updateData', { codeContract: this.item.geminisCodCont })
      })
    },
    calculatePercent(val) {
      if (val < 0) {
        val = 0
      }
      this.totalAmortPercent = 0
      val.map((el) => {
        let num = Number(el.percent)
        if (el.percent < 0) {
          el.percent = 0
        }
        console.log({ num })
        this.totalAmortPercent += num
      })
      if (this.totalAmortPercent > 100) {
        this.changeExedPercent()
      }
      this.$forceUpdate()
    },
    changeExedPercent() {
      this.$emit('changeExedPercent')
    },
    saveChangePasse() {
      this.$emit('saveChangePasse')
    },
    addElement(item, i) {
      let number = Number(this.numberAmort)
      this.numberAmort = number + 1
      let per = { percent: `` }

      this.showArray(this.numberAmort)
    },
    removeElement(item, i) {
      let number = Number(this.arrayAmort[i].percent)
      this.totalAmortPercent = this.totalAmortPercent - number
      this.numberAmort = this.numberAmort - 1
      item.splice(i, 1)

      this.showArray(this.numberAmort)
    },
    renderizTemplate() {
      if (this.numberAmort == null || this.numberAmort == '') {
        this.numberAmort = 0
      }
      this.showEditAmortization = true
    },
    cancelarAmortizacion() {
      this.numberAmort = ''
      this.showEditAmortization = false
    },
    getPercentTotal(passesMade, missingPasses) {
      /*Funcion que obtine los % del array con descripcion */
      let joinPercent = passesMade.concat(missingPasses)
      let join = []
      joinPercent.map((e) => {
        if (e.includes('%')) {
          let reduceElem = e.split(' ')
          reduceElem.map((el) => {
            if (el.includes('%')) {
              let elem = el.replace('%', '')
              console.log({ elem })
              join.push(Number(elem))
            }
          })
        }
      })
      return join
    },
    async realizarAmortizacion(val, item) {
      this.arraySend = []
      this.showEditAmortization = false
      let missingAmount = Number(
        this.item.missingMount
          .slice(4, this.item.missingMount.length - 1)
          .replace(',', '')
      )
      let unitePrice = Number(
        this.item.unitPrice.slice(4, this.item.missingMount.length - 1)
      )
      // Encontrar el precio
      let totalAmortPasadas = this.item.passesMade.map((el) => {
        if (el.includes('%')) {
          let index = el.indexOf('%')
          let num = Number(el.slice(12, index).replace(',', ''))
          return num
        } else {
          return 0
        }
      })

      totalAmortPasadas.map((el) => {
        if (el != 0) {
          return this.arraySend.push(el)
        }
      })
      let totalAmortFaltantes = this.item.missingPasses.map((el) => {
        if (el.includes('%')) {
          let index = el.indexOf('%')
          let num = Number(el.slice(12, index).replace(',', ''))
          return num
        } else {
          return 0
        }
      })
      let TotalPercenAmort =
        totalAmortPasadas.length == 0
          ? 0
          : totalAmortPasadas.reduce((a, b) => a + b)
      let TotalPercenMissing =
        totalAmortFaltantes.length == 0
          ? 0
          : totalAmortFaltantes.reduce((a, b) => a + b)
      let array = this.arrayAmort.map((e) => {
        return e
      })
      let totalPasses = item.numPasses - item.passesMade.length
      let typeCurrency = item.typeCurrency || 'USD'
      let newArray = []
      let numbers = []
      for (let i = 0; i < totalPasses; i++) {
        let percent = array[i] ? array[i].percent : 0
        let text =
          percent === 0
            ? `1 Pasada de     ${typeCurrency} 0.00`
            : `1 Pasada de       ${
                (percent * TotalPercenMissing).toFixed(2) / 100
              }%     ${typeCurrency} ${(
                (percent * missingAmount) /
                100
              ).toFixed(2)}`
        newArray.push(text)
        if ((percent * TotalPercenMissing).toFixed(3) / 100 != 0) {
          this.arraySend.push((percent * TotalPercenMissing).toFixed(3) / 100)
        }
      }
      let percentTotal = this.getPercentTotal(item.passesMade, newArray)
      console.log({ percentTotal })
      this.arraySend = this.arraySend
        .toString()
        .replace(/,/gi, ';')
        .replace(/\./g, ',')
      this.listMissingAmorts = newArray
      this.item.missingPasses = this.listMissingAmorts
      let today = moment(moment().toDate()).format('DD/MM/YYYY')
      let objSend = {
        conCode: this.item.geminisCodCont,
        matCode: this.item.geminisCodMat,
        capCode: this.item.numChapter,
        percentage: this.arraySend,
        numberPasses: this.quantPass,
        fechaAdenda: today,
        userName: this.userName,
      }
      await HTTP.patch(
        'orclcontracts/Passes/updateTipeAmortAndNumPasses',
        objSend
      )
        .then((res) => {
          console.log(res)
        })
        .catch((err) => console.log(err))
      this.$emit('makeAmortization', {
        item,
        percentTotal,
        chapter: this.chapterSelect,
        list: this.listChapters,
      })
    },
    gettingUsername() {
      let userEmail = localStorage.getItem('userEmail')
      let user = userEmail.split('@')[0]
      this.userName = user.toUpperCase()
    },
  },
  mounted() {
    this.gettingUsername()
    // this.$emit("material", {material: this.item.geminisCodMat})
  },
}
</script>

<style scoped>
.border__orange {
  border-right: 2px solid var(--color-orange);
  padding-right: 80px;
}
.style__amortizacionContract .el-button--gray {
  background-color: #555f79 !important;
  border-color: #555f79 !important;
}

.style__amortizacionContract .el-button--gray:hover {
  background-color: #7c8292 !important;
  border-color: #7c8292 !important;
}

.style__amortizacionContract .bg-orange {
  background-color: #ff5000 !important;
  opacity: 0.8;
}
</style>